/*---------------------------------------------------------------------------

   Swyx Solutions GmbH
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2003 Swyx Solutions GmbH.

  All Rights Reserved.

  ---------------------------------------------------------------------------

     Project:   Swyx Client SDK

      Module:   Simple MFC Client sample
 
    Comments:   

  ---------------------------------------------------------------------------

   $Archive:: /phone client/ClientSDK/Samples/Visual C++ Simple/MfcClientD $
    $Author:: Bruessler                                                    $
      $Date:: 24.11.00 14:40                                               $
   $Modtime:: 24.11.00 14:18                                               $
  $Revision:: 3                                                            $
  $Workfile:: MfcClientDlg.cpp                                             $
$NoKeywords: $
----------------------------------------------------------------------------*/

// MfcClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "MfcClient.h"
#include "MfcClientDlg.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//register window messages for signalling events to client
UINT glbWM_LineMgrNotification=RegisterWindowMessage(_T("WM_LineMgrNotification"));




/////////////////////////////////////////////////////////////////////////////
// CMfcClientDlg dialog
CMfcClientDlg::CMfcClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcClientDlg)
	m_ChatInput = _T("");
	m_ChatOutput = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    //initialize interface pointer
    m_pICLMgr=NULL;
    m_pICLMgr5=NULL;
    m_dwChatMessageReaderId=-1;
    m_pItemEventSink=NULL;
    m_adviseCookie=0;
    m_iSelectedLine=0;
    m_iMessageId=1;
}



CMfcClientDlg::~CMfcClientDlg()
{
}



void CMfcClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcClientDlg)
	DDX_Control(pDX, IDC_COMBO_TO, m_Receiver);
	DDX_Text(pDX, IDC_RICHEDIT_CHATIN, m_ChatInput);
	DDX_Text(pDX, IDC_RICHEDIT_CHATOUT, m_ChatOutput);
	//}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CMfcClientDlg, CDialog)
    //registered window message, send by client line manager
    ON_REGISTERED_MESSAGE(glbWM_LineMgrNotification, OnClientLineManagerEvent)

	//{{AFX_MSG_MAP(CMfcClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL CMfcClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    HRESULT hr;

    //create line manager object on local machine
    hr=CoCreateInstance(CLSID_ClientLineMgr, NULL, CLSCTX_LOCAL_SERVER, IID_IClientLineMgrPub,(void**)&m_pICLMgr);

    if(SUCCEEDED(hr))
    {
        hr=m_pICLMgr->QueryInterface(IID_IClientLineMgrPub5, (void**)&m_pICLMgr5);

        if(FAILED(hr))
        {
            m_pICLMgr5=NULL;
        }

        if(m_pICLMgr5)
        {
            hr=m_pICLMgr5->PubRegisterChatMessageReader(&m_dwChatMessageReaderId);
            if(FAILED(hr))
            {
                m_dwChatMessageReaderId=-1;
            }
        }

#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

        if(m_pItemEventSink==NULL)
        {
            //connect our event sink to the line managers connection point (event source)
            IConnectionPointContainer   *pConnPtContainer;
            IConnectionPoint            *pConnectionPoint;

            hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
            if(SUCCEEDED(hr))
            {
                //Find connection point for events you're interested in.
                hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                if(SUCCEEDED(hr))
                {
                    m_pItemEventSink=new CCLMgrEventSink;
                    m_pItemEventSink->m_pMfcClientDlg=this;
                    //Get the IUnknown interface of your event implementation.
                    LPUNKNOWN pUnk=m_pItemEventSink->GetInterface(&IID_IUnknown);
                    if(pUnk!=0)
                    {
                        //connect to event source
                        hr=pConnectionPoint->Advise(pUnk, &m_adviseCookie);
                        if(FAILED(hr))
                        {
                            m_adviseCookie=0;
                            delete m_pItemEventSink;
                            m_pItemEventSink=NULL;
                        }
                    }
                    pConnectionPoint->Release();
                }
                pConnPtContainer->Release();
            }
        }


#else //build targets "Win32 Debug" and "Win32 Release"

        //register our window as target for client line manager messages
        hr=m_pICLMgr->PubRegisterMessageTarget((long)m_hWnd, 0);

#endif

        long lNumberOfSpeedDials=0;
        hr=m_pICLMgr->PubGetNumberOfSpeedDials(&lNumberOfSpeedDials);
        if(hr==S_OK)
        {
            for(long l=0; l<lNumberOfSpeedDials; l++)
            {
                long lState=0;
                hr=m_pICLMgr->PubGetSpeedDialState(l, &lState);
                if(hr==S_OK && (lState>0))
                {
                    BSTR bstrName=NULL;

                    hr=m_pICLMgr->PubGetSpeedDialName(l, &bstrName);
                    if( (hr==S_OK) && (bstrName!=NULL) )
                    {
                        CString sName=bstrName;

                        if(sName!=_T(""))
                        {
                            if(m_Receiver.FindStringExact(-1, sName)==CB_ERR)
                            {
                                m_Receiver.AddString(sName);
                            }
                        }

                        SysFreeString(bstrName);
                        bstrName=NULL;
                    }
                }
            }
        }
    }        

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CMfcClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CMfcClientDlg::OnDestroy() 
{

#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

    if(m_pItemEventSink)
    {
        m_pItemEventSink->m_pMfcClientDlg=NULL;
        if(m_adviseCookie && m_pICLMgr)
        {
            //disconnect our event sink from the line managers connection point (event source)
            IConnectionPointContainer   *pConnPtContainer;
            IConnectionPoint            *pConnectionPoint;
            HRESULT                     hr;

            hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
            if(SUCCEEDED(hr))
            {
                //Find connection point for events you're interested in.
                hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                if(SUCCEEDED(hr))
                {
                    //release connection to event source
                    hr=pConnectionPoint->Unadvise(m_adviseCookie);
                    pConnectionPoint->Release();
                }
                pConnPtContainer->Release();
            }
        }
        m_adviseCookie=0;
        delete m_pItemEventSink;
        m_pItemEventSink=NULL;
    }

#else //build targets "Win32 Debug" and "Win32 Release"

    if(m_pICLMgr)
    {
        HRESULT hr=m_pICLMgr->PubUnRegisterMessageTarget((long)m_hWnd, 0);
    }

#endif


    //release remaining interfaces
    if(m_pICLMgr)
    {
        m_pICLMgr->Release();
        m_pICLMgr=NULL;
    }

    if(m_pICLMgr5)
    {
        if(m_dwChatMessageReaderId!=-1)
        {
            m_pICLMgr5->PubUnRegisterChatMessageReader(m_dwChatMessageReaderId);            
            m_dwChatMessageReaderId=-1;
        }
        m_pICLMgr5->Release();
        m_pICLMgr5=NULL;
    }


	CDialog::OnDestroy();
}



//used only in build targets "Win32 Debug" and "Win32 Release"
void CMfcClientDlg::OnClientLineManagerEvent(WPARAM wParam, LPARAM lParam)
{
    long            CLMgrMessage=wParam;
    _bstr_t         dialstring;
    int             iSignalledLine=-1;

    switch(CLMgrMessage)
    {

        case PubCLMgrLineStateChangedMessage:
            OnLineStateChanged(lParam);
            break;
            
        case PubCLMgrLineDetailsChangedMessage:
            OnLineDetailsChanged(lParam);
            break;

        case PubCLMgrLineSelectionChangedMessage:
            OnLineSelectionChanged(lParam);
            break;

        case PubCLMgrChatMessage:
            OnChatMessage();
            break;

        case PubCLMgrChatMessageAck:
            OnChatMessageAck(lParam);
            break;

        case PubCLMgrCallDetailsMessage:
        case PubCLMgrNumberOfLinesChangedMessage:
        case PubCLMgrClientShutDownRequest:
        case PubCLMgrHandsetStateChangedMessage:
        case PubCLMgrNameKeyStateChangedMessage:
        case PubCLMgrUserDataChangedMessage:
        case PubCLMgrGroupCallNotificationMessage:
        case PubCLMgrServerDownMessage:
        case PubCLMgrServerUpMessage:
        case PubCLMgrWaveDeviceChanged:
        case PubCLMgrPowerSuspendMessage:
        case PubCLMgrPowerResumeMessage:
        case PubCLMgrSkinPhoneCommandMessage:
        case PubCLMgrSkinActionAreaStateChangedMessage:
        case PubCLMgrSkinInfoDetailChangedMessage:
        case PubCLMgrCallbackOnBusyNotification:
        case PubCLMgrAsyncMessage:
        case PubCLMgrCtiPairingStateChanged:
        default:
            break;
    }

}



//state of a line has changed
void CMfcClientDlg::OnLineStateChanged(int iLine)
{
    HRESULT hr;

    IClientLinePub      *pILine=NULL;

    if(m_pICLMgr)    
    {
        hr=m_pICLMgr->PubGetLine(iLine, &pILine);

        if(SUCCEEDED(hr) && pILine)
        {
            long lState=PubLSNone;

            hr=pILine->PubGetState(&lState);

            switch(lState)
            {
                case PubLSRinging:
                case PubLSActive:
                    {
                        CString sPeerName;

                        if(GetPeerName(iLine, sPeerName) && (sPeerName!=_T("")))
                        {
                            if(m_Receiver.FindStringExact(-1, sPeerName)==CB_ERR)
                            {
                                m_Receiver.AddString(sPeerName);
                            }

                            if(!GetChatInput())
                            {
                                m_Receiver.SelectString(-1, sPeerName);
                            }
                        }
                    }
                    break;

                case PubLSTerminated:
                case PubLSBusy:
                case PubLSInactive:
                case PubLSHookOffInternal:
                case PubLSHookOffExternal:
                case PubLSDialing:
                case PubLSAlerting:
                case PubLSKnocking:
                case PubLSOnHold:
                case PubLSConferenceActive:
                case PubLSConferenceOnHold:
                case PubLSTransferring:
                case PubLSDisabled:
                default:
                    break;
            }

            pILine->Release();
        }
    }
}


void CMfcClientDlg::OnLineSelectionChanged(int iLine)
{
    CString sPeerName;
    
    m_iSelectedLine=iLine;

    if(GetPeerName(iLine, sPeerName) && (sPeerName!=_T("")))
    {
        if(m_Receiver.FindStringExact(-1, sPeerName)==CB_ERR)
        {
            m_Receiver.AddString(sPeerName);
        }

        if(!GetChatInput())
        {
            m_Receiver.SelectString(-1, sPeerName);
        }
    }
}



void CMfcClientDlg::OnLineDetailsChanged(int iLine)
{
    CString sPeerName;
    
    if(GetPeerName(iLine, sPeerName) && (sPeerName!=_T("")))
    {
        if(m_Receiver.FindStringExact(-1, sPeerName)==CB_ERR)
        {
            m_Receiver.AddString(sPeerName);
        }
    }
}



void CMfcClientDlg::OnChatMessage()
{
    if(m_pICLMgr5 && (m_dwChatMessageReaderId!=-1) )
    {
        PubCLMgrChatMsg ChatMsg;

        ChatMsg.m_dwPeerIpAddress=0;
        ChatMsg.m_sPeerName=NULL;
        ChatMsg.m_sMessageText=NULL;
        ChatMsg.m_ulMessageId=0;

        HRESULT hr=m_pICLMgr5->PubReadChatMessage(m_dwChatMessageReaderId, &ChatMsg);

        if(hr==S_OK)
        {
            PubCLMgrChatMsgAck ChatMsgAck;

            ChatMsgAck.m_ulMessageId=ChatMsg.m_ulMessageId;
            ChatMsgAck.m_sPeerName=ChatMsg.m_sPeerName;
	        ChatMsgAck.m_dwPeerIpAddress=ChatMsg.m_dwPeerIpAddress;

            hr=m_pICLMgr5->PubAcknowledgeChatMessage(ChatMsgAck);

            CString sFrom;
            CString sMessageText;

            if(ChatMsg.m_sPeerName)
            {
                sFrom=ChatMsg.m_sPeerName;
                SysFreeString(ChatMsg.m_sPeerName);
                ChatMsg.m_sPeerName=NULL;
                ChatMsgAck.m_sPeerName=NULL;
            }
            if(ChatMsg.m_sMessageText)
            {
                sMessageText=ChatMsg.m_sMessageText;
                SysFreeString(ChatMsg.m_sMessageText);
                ChatMsg.m_sMessageText=NULL;
            }

            m_ChatOutput+=CString("From ")+sFrom+CString(": ")+sMessageText+CString("\r\n");
            SetChatOutput();

            if(sFrom!="")
            {
                if(m_Receiver.FindStringExact(-1, sFrom)==CB_ERR)
                {
                    m_Receiver.AddString(sFrom);
                }

                if(!GetChatInput())
                {
                    m_Receiver.SelectString(-1, sFrom);
                }
            }
        }
    }
}



void CMfcClientDlg::OnChatMessageAck(int iMessageId)
{
}



void CMfcClientDlg::OnButtonSend() 
{
    if(GetReceiverName() && GetChatInput() && (m_ReceiverName!=_T("")))
    {
        if(m_pICLMgr5 && (m_dwChatMessageReaderId!=-1) )
        {
            PubCLMgrChatMsg ChatMsg;
            _bstr_t bstrReceiverName=m_ReceiverName;
            _bstr_t bstrMessageText=m_ChatInput;

            ChatMsg.m_dwPeerIpAddress=0;
            ChatMsg.m_sPeerName=bstrReceiverName;
            ChatMsg.m_sMessageText=bstrMessageText;
            ChatMsg.m_ulMessageId=m_iMessageId++;

            HRESULT hr=m_pICLMgr5->PubSendChatMessage(ChatMsg);

            if(SUCCEEDED(hr))
            {
                m_ChatOutput+=CString("To ")+m_ReceiverName+CString(": ")+m_ChatInput+CString("\r\n");
                SetChatOutput();
                ClearChatInput();

                if(m_Receiver.FindStringExact(-1, m_ReceiverName)==CB_ERR)
                {
                    m_Receiver.AddString(m_ReceiverName);
                }

                GetDlgItem(IDC_RICHEDIT_CHATIN)->SetFocus();
            }
        }
    }
}



bool CMfcClientDlg::GetPeerName(int iLine, CString &sPeerName)
{
    HRESULT         hr;
    IClientLinePub  *pILine=NULL;
    bool            bRetVal=false;

    if(m_pICLMgr)    
    {
        hr=m_pICLMgr->PubGetLine(iLine, &pILine);

        if(SUCCEEDED(hr) && pILine)
        {
            PubCLMgrLineDetails Details;

            hr=pILine->PubGetDetails(&Details);

            if(Details.m_sPeerName)
            {
                sPeerName=Details.m_sPeerName;
                bRetVal=true;
            }

            SysFreeString(Details.m_sAcknowledgedDialstring);
            SysFreeString(Details.m_sPeerNumber);
            SysFreeString(Details.m_sPeerName);
            SysFreeString(Details.m_sCalledExtension);
            SysFreeString(Details.m_sCalledName);
            SysFreeString(Details.m_sRedirectedFromNumber);
            SysFreeString(Details.m_sRedirectedFromName);
            SysFreeString(Details.m_sBlindCallTransferSourceNumber);
            SysFreeString(Details.m_sBlindCallTransferSourceName);
            SysFreeString(Details.m_sChargingDetails);

            pILine->Release();
        }
    }

    return bRetVal;
}



bool CMfcClientDlg::GetChatInput()
{
    CWnd *pDlgItem=GetDlgItem(IDC_RICHEDIT_CHATIN);
    if(pDlgItem)
    {
        pDlgItem->GetWindowText(m_ChatInput);
    }
    else
    {
        m_ChatInput="";
    }

    return m_ChatInput.GetLength()>0;
}



bool CMfcClientDlg::GetReceiverName()
{
    CWnd *pDlgItem=GetDlgItem(IDC_COMBO_TO);
    if(pDlgItem)
    {
        pDlgItem->GetWindowText(m_ReceiverName);
    }
    else
    {
        m_ReceiverName="";
    }

    return m_ReceiverName.GetLength()>0;
}



void CMfcClientDlg::SetChatOutput()
{
    CWnd *pDlgItem=GetDlgItem(IDC_RICHEDIT_CHATOUT);
    if(pDlgItem)
    {
        pDlgItem->SetWindowText(LPCTSTR(m_ChatOutput));
    }
}



void CMfcClientDlg::ClearChatInput()
{
    CWnd *pDlgItem=GetDlgItem(IDC_RICHEDIT_CHATIN);
    if(pDlgItem)
    {
        pDlgItem->SetWindowText("");
    }
    m_ChatInput="";
}
