/*---------------------------------------------------------------------------

   Swyx Solutions GmbH
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2003 Swyx Solutions GmbH.

  All Rights Reserved.

  ---------------------------------------------------------------------------

     Project:   Swyx Client SDK

      Module:   Simple MFC Client sample
 
    Comments:   

  ---------------------------------------------------------------------------

   $Archive:: /phone client/ClientSDK/Samples/Visual C++ Simple/MfcClientD $
    $Author:: Bruessler                                                    $
      $Date:: 24.11.00 14:40                                               $
   $Modtime:: 24.11.00 14:05                                               $
  $Revision:: 3                                                            $
  $Workfile:: MfcClientDlg.h                                               $
$NoKeywords: $
----------------------------------------------------------------------------*/

// MfcClientDlg.h : header file
//

#if !defined(AFX_MFCCLIENTDLG_H__27BAE9B0_CE25_4D96_8A8C_334501A12412__INCLUDED_)
#define AFX_MFCCLIENTDLG_H__27BAE9B0_CE25_4D96_8A8C_334501A12412__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMfcClientDlg dialog

class CCLMgrEventSink;

class CMfcClientDlg : public CDialog
{
// Construction
public:
	CMfcClientDlg(CWnd* pParent = NULL);	// standard constructor
	~CMfcClientDlg();

// Dialog Data
	//{{AFX_DATA(CMfcClientDlg)
	enum { IDD = IDD_MFCCLIENT_DIALOG };
	CComboBox	m_Receiver;
	CString	m_ChatInput;
	CString	m_ChatOutput;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfcClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL



    IClientLineMgrPub   *m_pICLMgr;
    IClientLineMgrPub5  *m_pICLMgr5;

    CCLMgrEventSink     *m_pItemEventSink;
    DWORD               m_adviseCookie;
    DWORD               m_dwChatMessageReaderId;
    int                 m_iSelectedLine;
    int                 m_iMessageId;
	CString	            m_ReceiverName;

public:

    //state of a line has changed
    void OnLineStateChanged(int iLine);
    void OnLineSelectionChanged(int iLine);
    void OnLineDetailsChanged(int iLine);
    void OnChatMessage();
    void OnChatMessageAck(int iMessageId);
    bool GetPeerName(int iLine, CString &sPeerName);
    bool GetChatInput();
    void ClearChatInput();
    bool GetReceiverName();
    void SetChatOutput();

// Implementation
protected:
	HICON m_hIcon;

    afx_msg void OnClientLineManagerEvent(WPARAM wParam, LPARAM lParam);
    
	// Generated message map functions
	//{{AFX_MSG(CMfcClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnButtonSend();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFCCLIENTDLG_H__27BAE9B0_CE25_4D96_8A8C_334501A12412__INCLUDED_)
